#include "ui_dinasms.h"
#include "ui_login.h"
#include "ui_history.h"
#include "dinasms.h"
#include "login.h"
#include "history.h"
#include <contact.h>
#include <ui_contact.h>
#include "qtreecustom.h"
#include "mylineedit.h"
#include <QCursor>
#include "synchttp.h"
#include <QDebug>
#include <QRegExpValidator>
#include <QMessageBox>
#include <QInputDialog>
#include <QtXml/QXmlStreamReader>
#include <QListWidget>
#include <QHostAddress>
#include <QNetworkInterface>

extern QTranslator translator;
extern QApplication *a;

dinasms::dinasms(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::dinasms)
{
    ui->setupUi(this);
    ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
    QObject::connect( &l, SIGNAL(logSuccess(QString,QString)),this, SLOT(CheckLogin(QString,QString)) );
    QObject::connect( &l, SIGNAL(Remember(bool)),this, SLOT(ChangeLanguage(bool)) );
    QObject::connect( this, SIGNAL(Lang(bool)),&l, SLOT(ChangeLangu(bool)) );
    if(!l.AutoLogin())  l.show();
}

dinasms::~dinasms()
{
    QFile file(".dina.cfg");
    if (file.open (QFile::ReadOnly))
    {
      QTextStream stream ( &file );
      QString line = stream.readLine();
      QString line1 = stream.readLine();
      QString line2 = stream.readLine();
      line2 = line2.split(':')[0] + ":" +line2.split(':')[1] + ":"+line2.split(':')[2] + ":" + line2.split(':')[3] + ":"+ ui->limit->text().toAscii();
      file.close();
      QFile file1(".dina.cfg");
      if (file1.open (QFile::WriteOnly))
      {
         QTextStream stream1 ( &file1 );
         stream1 << line << "\n"; stream1 << line1 << "\n";stream1 << line2;
         file.close();
      }
    }
    delete ui;
}

void dinasms::ChangeLanguage(bool lang)
{
   if(lang)
        translator.load(":/dinasms_en");
    else
        translator.load(":/dinasms_sp");
    //a->installTranslator(&translator);
    ui->retranslateUi(this);
   // l.ui->retranslateUi(&l);
    emit(Lang(lang));
}

void  dinasms::AddItem(QStringList list,QTreeWidgetItem *item)
{
    ui->centralWidget->setCursor(QCursor(Qt::WaitCursor));
    if(item->parent()!= NULL)
        item = item->parent();
    QString num = "";
    if(hash.count() == item->childCount())
    {
        msgBox.setText(tr("All contacts Already in the List!"));
        msgBox.exec();
        ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
        return;
    }
    foreach(QString l,list)
    {
        QString  k = hash[l];
        QStringList ll = k.split("|");
        num += ll[0]+",";
    }
    for(int u=0; u < item->childCount();u++)
    {
        QString  k = hash[item->child(u)->text(0)];
        QStringList ll = k.split("|");
        if(!num.contains(ll[0]))
                    num += ll[0]+",";
    }
    QString result = this->Post("cuenta="+user+"&password="+pass+"&lista="+item->text(0)+"&ids="+num+"&command=sms_updateLists");
    if (this->CheckError(result))
    {
       msgBox.setText(tr("Added Contact to the List SuccessFully!"));
       msgBox.exec();
       this->LoadView();
       ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
       return;
    }
    else
    {
       msgBox.setText(tr("Failed Adding the Contact to the List!"));
       msgBox.exec();
       ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
       return;
    }
}

QString dinasms::Post(QString Postdata)
{
    SyncHTTP h("apisms.gestiondecuenta.com");
    QByteArray data(Postdata.toAscii());
    QBuffer postOutput;
    h.syncPost( "/php/comun/ejecutarComando.php",data, &postOutput);
    return  trUtf8(postOutput.data());
}

bool dinasms::CheckError(QString result){
    QRegExp rx("(<ErrCount>)([0-9]+)(</ErrCount>)");
    int pos = rx.indexIn(result);
    if (pos > -1 && rx.cap(2).compare("0")==0)
            return true;
        return false;
}

void dinasms::LoadButton()
{
    count++;
    this->LoadHistory();
}

void dinasms::ShowLogin()
{
    l.show();
}

void dinasms::SendSMS()
{
  if(ui->sender->text().isEmpty() || ui->to->text().isEmpty() || ui->message->toPlainText().isEmpty())
  {
      msgBox.setText(tr("Please Enter All Details to Message!"));
      msgBox.exec();
      return;
  }
  ui->centralWidget->setCursor(QCursor(Qt::WaitCursor));
  QStringList items;
  foreach(QNetworkInterface interface, QNetworkInterface::allInterfaces())
  {
     if (interface.flags().testFlag(QNetworkInterface::IsRunning))
       foreach (QNetworkAddressEntry entry, interface.addressEntries())
         if ( interface.hardwareAddress() != "00:00:00:00:00:00" &&     entry.ip().toString().contains("."))
           items <<  entry.ip().toString();
  }

  QString total = QString::number(ui->to->text().split(',').length());
  QString poster = "cuenta="+ user+"&password="+pass+"&command=sms_sendBulk&sms="+ui->message->toPlainText()+"&sms_n_msgs="+ total +"&remite="+ui->sender->text()+"&ip="+items[0];
  for(int r =0; r < ui->to->text().split(',').length(); r++)
      poster = poster + "&sms_to[" +  QString::number(r) + "]=" + ui->to->text().split(',')[r];
  if(ui->deliver->isChecked())
  {
      QDateTime q(ui->date->date(),ui->time->time());
      QDateTime timeNow = QDateTime::currentDateTime();
       int secs = timeNow.secsTo(q)/60;
      poster = poster + "&programar="+ QString::number(secs);
  }
  QString result =  this->Post(poster);
  if (CheckError(result))
  {
     QRegExp from("(<enviados>)(.*)(</enviados>)");
     QString result = this->Post("cuenta="+user+"&password="+pass+"&command=sms_getAddressBook");
     QXmlStreamReader xml(result);
     QRegExp credit("(<smsCredit>)([0-9]+)(.*)(</smsCredit>)");
     credit.indexIn(result);
     ui->logstats->setText(credit.cap(2)+ tr(" credits | ")+tr("Connected as : ") + user);
     ui->Creditlabel->setText(credit.cap(2)+tr(" credits available"));
     msgBox.setText(tr("SMS Sent Successfully!"));
     msgBox.exec();
     this->ClearAll();
   }
  else
  {
      msgBox.setText(tr("Failed Sending SMS!"));
      msgBox.exec();
  }
  ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
}

void dinasms::ClearAll()
{
    ui->date->setDate(QDate::currentDate());
    ui->date->setMinimumDate(QDate::currentDate());
    ui->time->setTime(QTime::currentTime());
    ui->time->setMinimumTime(QTime::currentTime());
    ui->to->setText("");
    QString result = this->Post("cuenta="+ user+"&password="+pass+"&command=sms_Login");
    QRegExp from("(<defaultFrom>)(.*)(</defaultFrom>)");
    from.indexIn(result);
    QString text = from.cap(2);
    ui->sender->setText(text.replace(QRegExp("&.*;")," "));
    ui->currentSender->setText(text.replace(QRegExp("&.*;")," "));
    QRegExp credit("(<smsCredit>)([0-9]+)(.*)(</smsCredit>)");
    credit.indexIn(result);
    ui->logstats->setText(credit.cap(2)+ tr(" credits | ")+tr("Connected as : ") + user);
    ui->Creditlabel->setText(credit.cap(2)+tr(" credits available"));
    ui->message->setText("");
}

void dinasms::CheckLogin(QString u,QString p)
{
    QFile file(".dina.cfg");
    if (file.open (QFile::ReadOnly))
    {
        QTextStream stream ( &file );
    stream.readLine();stream.readLine();
    QString line = stream.readLine();
    file.close();
    if(line.split(':').length() == 5)
        ui->limit->setText(line.split(':')[4]);
    }
    l.hide();
    ui->comboBox->hide();
    count=1;
    ui->centralWidget->setCursor(QCursor(Qt::WaitCursor));
    ui->date->setDate(QDate::currentDate());
    ui->date->setMinimumDate(QDate::currentDate());
    ui->time->setTime(QTime::currentTime());
    ui->time->setMinimumTime(QTime::currentTime());
    user=u;pass=p;    
    ui->to->setText("");ui->message->setText("");
    QString result = this->Post("cuenta="+ user+"&password="+pass+"&command=sms_Login&so=lin&version=1.0.0");
    QRegExp from("(<defaultFrom>)(.*)(</defaultFrom>)");
    from.indexIn(result);
    QString text = from.cap(2);

    QRegExp update("(<version><last>)(.*)(</last><update>)(.*)(</update>)");
    update.indexIn(result);
    QString version = update.cap(2);
    QString upd = update.cap(4);

    QRegExp link("(<url>)(.*)(</url>)");
    link.indexIn(result);
    QStringList l1 = version.split('.');

    bool flagger = false;
    if( l1.at(0).toInt() > 1 ) flagger = true;
    if(l1.length() >= 2 &&  l1.at(0).toInt() == 1 && l1.at(1).toInt() > 0) flagger = true;
    if(l1.length() == 3 &&  l1.at(0).toInt() == 1 && l1.at(1).toInt() == 0 && l1.at(2).toInt() > 0) flagger = true;

    if( flagger )
    {
    if(upd == "REQUIRED" )
    {
       // QMessageBox msgBox;
        QString message = tr("The application will be updated to version ");
        msgBox.setText(message+version);
        msgBox.exec();
        this->close();
        QProcess* process;
        process->start("firefox", QStringList() << link.cap(2));
        return;
    }
    else if(upd == "MUST" )
    {
        QString message = tr("The application should be updated to version ");
        QString message1 = tr("Do you want to do it now? ");
        QString main = message +  version;
        if(QMessageBox::question(this,message1,main,QMessageBox::Yes |QMessageBox::No) == QMessageBox::Yes )
        {
            //raise the Link
            QProcess* process = new QProcess(this);
            process->start("firefox", QStringList() << link.cap(2));
        }
    }
    else if(upd == "OPTIONAL" )
    {
        QString message = tr("The application could be updated to version ");
        QString message1 = tr("Do you want to do it now? ");
        QString main = message +  version;
        if(QMessageBox::question(this,message1,main,QMessageBox::Yes |QMessageBox::No) == QMessageBox::Yes )
        {
            //raise the Link
            QProcess* process = new QProcess(this);
            process->start("firefox", QStringList() << link.cap(2));
        }
    }
    }
    this->show();
    ui->sender->setText(text.replace(QRegExp("&.*;")," "));
    ui->currentSender->setText(text.replace(QRegExp("&.*;")," "));
    QRegExp credit("(<smsCredit>)([0-9]+)(.*)(</smsCredit>)");
    credit.indexIn(result);
    ui->logstats->setText(credit.cap(2)+tr(" credits | ")+tr("Connected as : ") + user);
    ui->Creditlabel->setText(credit.cap(2)+tr(" credits available"));
    this->LoadView();
    ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
}


void dinasms::LoadView()
{
    ui->contacts->clear();
    ui->contactview->clear();
    ui->distribution->clear();
    ui->distlistview->clear();
    hash.clear();
    this->ContactsXML();
    this->ListsXML();
    ui->contacts->sortItems(0,Qt::AscendingOrder);
    ui->contactview->sortItems(0,Qt::AscendingOrder);
    ui->distribution->sortItems(0,Qt::AscendingOrder);
    ui->distlistview->sortItems(0,Qt::AscendingOrder);
    ui->clabel->setText(QString::number(ui->contacts->topLevelItemCount()) + tr(" contacts in your address book"));
    ui->dlabel->setText(QString::number(ui->distlistview->topLevelItemCount()) + tr(" lists created at this moment"));
}

void dinasms::EditCnt(QString name,QString number,QString key)
{
    QString result = this->Post("cuenta="+user+"&password="+pass+"&update[0][id]="+ key +"&update[0][name]="+ name +"&update[0][number]=" + number +"&command=sms_updateAddressBook");
    if (CheckError(result))
    {
       msgBox.setText(tr("Contact Edited Successfully!"));
       msgBox.exec();
       this->LoadView();
       ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
       return;
     }
    else
    {
        msgBox.setText(tr("Failed Editing Contact!"));
        msgBox.exec();
        ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
        return;
    }
}

void dinasms::EditContact()
{
    ui->centralWidget->setCursor(QCursor(Qt::WaitCursor));
    if( ui->tabWidget->currentIndex() == 1 )
    {
        QTreeWidgetItem *item = ui->contactview->currentItem();
        if(item == NULL)
        {
            msgBox.setText(tr("Select a Contact to Edit!"));
            msgBox.exec();
            ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
            return;
        }
        contact *w = new contact();w->setGeometry((int)(QApplication::desktop()->width() -
                                                        (QApplication::desktop()->width() -
                                                          (QApplication::desktop()->width() / 2)) * 1.5) / 2,
                                                          (int)(QApplication::desktop()->height() -
                                                        (QApplication::desktop()->height() -
                                                          (QApplication::desktop()->height() / 2)) * 1.5) / 2,
                                                          (int)((QApplication::desktop()->width() -
                                                        (QApplication::desktop()->width() / 2)) * 1.5),
                                                          (int)((QApplication::desktop()->height() -
                                                        (QApplication::desktop()->height() / 2)) * 1.5));
        QStringList l = hash[item->text(0)].split("|");
        QObject::connect( w, SIGNAL(EditSignal(QString,QString,QString)), this, SLOT(EditCnt(QString,QString,QString)));
        w->Addmode(1,l[0]);
        w->ShowAddWindow(item->text(0),l[1]);
        w->show();
    }
    else if( ui->tabWidget->currentIndex() == 2)
    {
        QTreeWidgetItem *item = ui->distlistview->currentItem();
        if(item == NULL)
        {
            msgBox.setText(tr("Select a Distribution List/contact to Edit!"));
            msgBox.exec();
            ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
            return;
        }
        if(item->parent() != NULL)
                item = item->parent();
        bool ok = 0;
        QString ListName = QInputDialog::getText (this, tr("Distribution List name"),tr("name :"), QLineEdit::Normal, item->text(0), &ok);
        if(ok && !ListName.isEmpty ())
        {
           QString result = this->Post("cuenta="+user+"&password="+pass+"&newNameList="+ ListName +"&oldNameList="+ item->text(0)+"&command=sms_modifyNameList");
           if(this->CheckError(result))
           {
              msgBox.setText(tr("Edited the List Successfully!"));
              msgBox.exec();
             this->LoadView();
              ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
              return;
           }
           else
           {
               msgBox.setText(tr("Failed Editing name of the List!"));
               msgBox.exec();
               ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
               return;
           }
        }
    }
    else
    {
        QTreeWidgetItem *item = ui->contacts->currentItem();
        if(item == NULL)
        {
            msgBox.setText(tr("Select a Contact to Edit!"));
            msgBox.exec();
            ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
            return;
        }
        contact *w = new contact();w->setGeometry((int)(QApplication::desktop()->width() -
                                                        (QApplication::desktop()->width() -
                                                          (QApplication::desktop()->width() / 2)) * 1.5) / 2,
                                                          (int)(QApplication::desktop()->height() -
                                                        (QApplication::desktop()->height() -
                                                          (QApplication::desktop()->height() / 2)) * 1.5) / 2,
                                                          (int)((QApplication::desktop()->width() -
                                                        (QApplication::desktop()->width() / 2)) * 1.5),
                                                          (int)((QApplication::desktop()->height() -
                                                        (QApplication::desktop()->height() / 2)) * 1.5));
        QStringList l = hash[item->text(0)].split("|");
        w->Addmode(1,l[0]);
        w->ShowAddWindow(item->text(0),l[1]);
        QObject::connect( w, SIGNAL(EditSignal(QString,QString,QString)), this, SLOT(EditCnt(QString,QString,QString)));
        w->show();
    }
    ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
}

void dinasms::RmContact()
{
    ui->centralWidget->setCursor(QCursor(Qt::WaitCursor));
    if( ui->tabWidget->currentIndex() == 1 )
    {
        QTreeWidgetItem *item = ui->contactview->currentItem();
        if(item == NULL)
        {
            msgBox.setText(tr("Select a Contact to delete!"));
            msgBox.exec();
            ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
            return;
        }

        if(QMessageBox::question(this, tr("Delete the Contact"),tr("Are you sure?"),QMessageBox::Yes |QMessageBox::No) == QMessageBox::Yes )
        {
             QString k = hash[item->text(0)];
             QStringList l = k.split("|");
             QString result = this->Post("cuenta="+user+"&password="+pass+"&delete[0][id]="+ l[0]+"&command=sms_updateAddressBook");
             if (CheckError(result))
             {
                msgBox.setText(tr("Contact Deleted Successfully!"));
                msgBox.exec();
                this->LoadView();
                ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
                return;
              }
              else
              {
                 msgBox.setText(tr("Failed Deleting Contacts!"));
                 msgBox.exec();
                 ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
                 return;
              }
          }
    }
    else if( ui->tabWidget->currentIndex() == 2)
    {
        QTreeWidgetItem *item = ui->distlistview->currentItem();
        if(item == NULL)
        {
            msgBox.setText(tr("Select a Distribution List/contact to delete!"));
            msgBox.exec();
            ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
            return;
        }
        if(item->parent() == NULL)
        {
            if(QMessageBox::question(this, tr("Delete the List"),tr("Are you sure?"),QMessageBox::Yes |QMessageBox::No) == QMessageBox::Yes)
            {
               QString result = this->Post("cuenta="+user+"&password="+pass+"&list="+ item->text(0)+"&command=sms_delList");
               if(this->CheckError(result))
               {
                   msgBox.setText(tr("Deleted the List Successfully!"));
                   msgBox.exec();
                   this->LoadView();
                   ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
                   return;
                }
                else
                {
                    msgBox.setText(tr("Failed Deleting the List!"));
                    msgBox.exec();
                    ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
                    return;
                }
              }
        }
        else
        {
          if(QMessageBox::question(this, tr("Delete the Contact"),tr("Are you sure?"),QMessageBox::Yes |QMessageBox::No) == QMessageBox::Yes)
          {
              QTreeWidgetItem *item1 = item->parent();
              QString num = "";
              for(int u=0; u < item1->childCount();u++)
              {
                  if(item->text(0) == item1->child(u)->text(0))
                               continue;
                  QString  k = hash[item1->child(u)->text(0)];
                  QStringList ll = k.split("|");
                  num += ll[0]+",";
               }
               QString result = this->Post("cuenta="+user+"&password="+pass+"&lista="+item1->text(0)+"&ids="+num+"&command=sms_updateLists");
               if (this->CheckError(result))
               {
                   msgBox.setText(tr("Deleted Contact From the List SuccessFully!"));
                   msgBox.exec();
                   this->LoadView();
                   ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
                   return;
               }
               else
               {
                  msgBox.setText(tr("Failed Deleting the Contact from the List!"));
                  msgBox.exec();
                  ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
                  return;
               }
           }
        }
    }
    else
    {
        QTreeWidgetItem *item = ui->contacts->currentItem();
        if(item == NULL)
        {
            msgBox.setText(tr("Select a Contact to delete!"));
            msgBox.exec();
            ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
            return;
        }
        if(QMessageBox::question(this, tr("Delete the Contact"),tr("Are you sure?"),QMessageBox::Yes |QMessageBox::No) == QMessageBox::Yes)
        {
            QString k = hash[item->text(0)];
            QStringList l = k.split("|");
            QString result = this->Post("cuenta="+user+"&password="+pass+"&delete[0][id]="+ l[0]+"&command=sms_updateAddressBook");
            if (CheckError(result))
            {
               msgBox.setText(tr("Contact Deleted Successfully!"));
               msgBox.exec();
               this->LoadView();
               ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
               return;
             }
            else
            {
                msgBox.setText(tr("Failed Deleting the Contacts!"));
                msgBox.exec();
                ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
                return;
            }
         }
    }

        ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
}

void dinasms::NewList()
{
    bool ok = 0;
    QString newlist = QInputDialog::getText (this, tr("Enter name of the new Distribution List"),tr("Distribution List :"), QLineEdit::Normal, "", &ok);
    if(ok && !newlist.isEmpty ())
    {
        QString result = this->Post("cuenta="+user+"&password="+pass+"&newList="+ newlist +"&command=sms_addList");
        if (this->CheckError(result))
        {
           msgBox.setText(tr("Created New List Successfully!"));
           msgBox.exec();
           this->LoadView();
           return;
         }
    }
    msgBox.setText(tr("No New List Created now!"));
    msgBox.exec();
}

void dinasms::AddCnt(QString name,QString number)
{
    QString result = this->Post("cuenta="+user+"&password="+pass+"&add[0][name]="+name+"&add[0][number]="+number+"&&command=sms_updateAddressBook");
    if (this->CheckError(result))
   {
      msgBox.setText(tr("Added new Contact Successfully!"));
      msgBox.exec();
      this->LoadView();
    }
    else
    {
        msgBox.setText(tr("Failed Adding new Contact!"));
        msgBox.exec();
    }
    ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
}

void dinasms::NewContact()
{
    contact *w = new contact();w->setGeometry((int)(QApplication::desktop()->width() -
                                                    (QApplication::desktop()->width() -
                                                      (QApplication::desktop()->width() / 2)) * 1.5) / 2,
                                                      (int)(QApplication::desktop()->height() -
                                                    (QApplication::desktop()->height() -
                                                      (QApplication::desktop()->height() / 2)) * 1.5) / 2,
                                                      (int)((QApplication::desktop()->width() -
                                                    (QApplication::desktop()->width() / 2)) * 1.5),
                                                      (int)((QApplication::desktop()->height() -
                                                    (QApplication::desktop()->height() / 2)) * 1.5));
    w->Addmode(0,"");
   QObject::connect( w, SIGNAL(AddSignal(QString,QString)), this, SLOT(AddCnt(QString,QString)));
   w->show();
}

void dinasms::AddtoList(QTreeWidgetItem *lista)
{
    bool ok = 0;
    QStringList l;
    QTreeWidgetItemIterator it(ui->contacts);
    while (*it)
    {
        bool flag = true;
        for(int u=0; u < lista->childCount();u++)
            if((*it)->text(0) == lista->child(u)->text(0))
                flag=false;
        if(flag)
            l << (*it)->text(0);
            ++it;
    }
    if(hash.count() == lista->childCount())
    {
        msgBox.setText(tr("All contacts Already in the List!"));
        msgBox.exec();
        return;
    }
    QString name = QInputDialog::getItem (this, tr("Add the Contacts to the selected Distribution List"),tr("Select"),l,0,false,&ok);
    if  (ok && !name.isEmpty ())
    {
        QString num = "";
        for(int u=0; u < lista->childCount();u++)
        {
            QString  k = hash[lista->child(u)->text(0)];
            QStringList ll = k.split("|");
            num += ll[0]+",";
        }

        QString k = hash[name];
        QStringList ll = k.split("|");
        num += ll[0];
        QString result = this->Post("cuenta="+user+"&password="+pass+"&lista="+lista->text(0)+"&ids="+num+"&command=sms_updateLists");
        if (this->CheckError(result))
        {
           msgBox.setText(tr("Added Contact to the List SuccessFully!"));
           msgBox.exec();
           this->LoadView();
           ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
           return;
        }
        else
        {
           msgBox.setText(tr("Failed Adding the Contact to the List!"));
           msgBox.exec();
           ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
           return;
        }
    }
}

void dinasms::AddContact()
{
    ui->centralWidget->setCursor(QCursor(Qt::WaitCursor));
    QTreeWidgetItem *item = ui->distlistview->currentItem();
    switch(ui->tabWidget->currentIndex())
    {
    case(1):
        this->NewContact();
        break;
    case(2):
        if(item == NULL)
           this->NewList();
        else if(item->parent() == NULL)
        {
                bool ok = 0; QStringList l;
                l << tr("Create A new List") << QString(tr("Add a Contact to ")+item->data(0,0).toString());
                QString name = QInputDialog::getItem (this, tr("Make a choice "),tr("Select"),l,0,false,&ok);
                if  (ok && !name.isEmpty ())
                {
                    if(name == tr("Create A new List"))
                        this->NewList();
                    else
                        this->AddtoList(item);
                }
        }
        else
            this->AddtoList(item->parent());
        break;
    default:
            ui->comboBox->show();
            break;
    }
    ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
}

void dinasms::AddNewContact()
{
    if(ui->comboBox->currentIndex() == 1)
        this->NewList();
    if(ui->comboBox->currentIndex() == 2)
        this->NewContact();
    ui->comboBox->hide();
}

void dinasms::ListsXML()
{
    QString result = this->Post("cuenta="+user+"&password="+pass+"&command=sms_getLists");
    QXmlStreamReader xml(result);
    while(!xml.atEnd() &&  !xml.hasError())
    {
         xml.readNext();
         if(xml.name() == "list")
         {
             QTreeWidgetItem *item = new QTreeWidgetItem(ui->distribution);
             QTreeWidgetItem *item1 = new QTreeWidgetItem(ui->distlistview);
             xml.readNext();xml.readNext();
             item->setText(0,xml.text().toString());
             item->setIcon(0,QIcon(":/images/groups.ico"));
             item1->setIcon(0,QIcon(":/images/groups.ico"));
             item1->setText(0,xml.text().toString());
             xml.readNext();
             while(xml.name() != "nRcpts")
             {
                  xml.readNext();
                  if(xml.name() == "id")
                  {
                    xml.readNext();
                   // qDebug() << "id : " << xml.text().toString() << "\n";
                    xml.readNext();xml.readNext();
                  }
                  if(xml.name() == "name")
                  {
                    QTreeWidgetItem *itemChild = new QTreeWidgetItem(item);
                    QTreeWidgetItem *item1Child = new QTreeWidgetItem(item1);
                    xml.readNext();
                    //qdebug() << "name : " << xml.text().toString() << "\n";
                    itemChild->setText(0,xml.text().toString());
                     QPixmap pixmap;
                     pixmap.load(":/images/user.ico");
                     itemChild->setIcon(0,QIcon(pixmap));
                     item1Child->setText(0,xml.text().toString());
                     item1Child->setIcon(0,QIcon(":/images/user.ico"));
                     xml.readNext();xml.readNext();
                     if(xml.name() == "number")
                     {
                       xml.readNext();
                       //qdebug() << "number : " << xml.text().toString() << "\n";
                       item1Child->setText(1,xml.text().toString());
                       item1Child->setIcon(1,QIcon(":/images/call.ico"));
                       xml.readNext();
                      }
                   }
              }
             if(xml.name() == "nRcpts")
             {
               xml.readNext();
               item->setText(1,xml.text().toString());
               item1->setText(1,xml.text().toString());
               xml.readNext();xml.readNext();
            }
        }
      }
      if(xml.hasError())
               QMessageBox::critical(this,"QXSRExample::parseXML",xml.errorString(),QMessageBox::Ok);
   xml.clear();
}

void dinasms::LoadSMSHistory()
{
    QScrollArea* scrollArea = new QScrollArea;
    QFrame *widget = new QFrame;
    scrollArea->setWidgetResizable(true);
    scrollArea->setWidget(widget);
    QVBoxLayout* MainLayout = new QVBoxLayout;
    scrollArea->setStyleSheet("background-color:rgb(83, 83, 83);");
    int z = count*ui->limit->text().toInt();
    QString result = this->Post("cuenta="+user+"&password="+pass+"&start=0&show="+QString::number(z)+"&end="+QString::number(z)+"&folder=ENVIO&programmed=true&command=sms_getFolderContent");
    QXmlStreamReader xml(result);
    QString name;QString number;QString text;QString date;
    while(!xml.atEnd() &&  !xml.hasError())
    {
         xml.readNext();
         /*if(xml.name() == "name")
         {
             xml.readNext();
             QString name = xml.text().toString();
             xml.readNext(); xml.readNext(); xml.readNext();
             QString number = xml.text().toString();
             xml.readNext(); xml.readNext();xml.readNext(); xml.readNext();
             xml.readNext(); xml.readNext(); xml.readNext();
             QString date = xml.text().toString();
             xml.readNext(); xml.readNext(); xml.readNext();
             QString text = xml.text().toString();
             history *w = new history;
             w->SetText(name+"        ["+number+"]                      ",text,date);
             MainLayout->addWidget(w);
         }*/
         if(xml.name() == "name")
         {
             xml.readNext();
             name = xml.text().toString();
             if(!name.isEmpty()) xml.readNext();
         }
         if(xml.name() == "number")
         {
             xml.readNext();
             number = xml.text().toString();
             if(!number.isEmpty()) xml.readNext();
         }
         if(xml.name() == "date")
         {
             xml.readNext();
             date = xml.text().toString();
             if(!date.isEmpty()) xml.readNext();
         }
         if(xml.name() == "text")
         {
             xml.readNext();
             text = xml.text().toString();
             if(!text.isEmpty()) xml.readNext();
             history *w = new history;                 
             if(name == number || name.isEmpty() )
                 w->SetText(number,text,date);
             else
                 w->SetText(name+"  ["+number+"]",text,date);
             MainLayout->addWidget(w);
         }
    }
    widget->setLayout(MainLayout);
    ui->history->addTab(scrollArea ,tr("History"));
    ui->history->removeTab(0);
}

void dinasms::LoadBulkSMSHistory()
{
    QScrollArea* scrollArea = new QScrollArea;
    QFrame *widget = new QFrame;
    scrollArea->setWidgetResizable(true);
    scrollArea->setWidget(widget);
    QVBoxLayout* MainLayout = new QVBoxLayout;
    scrollArea->setStyleSheet("background-color:rgb(83, 83, 83);");
    int z = count*ui->limit->text().toInt();
    QString result = this->Post("cuenta="+user+"&password="+pass+"&start=0&show="+QString::number(z)+"&end="+QString::number(z)+"&command=sms_getMassiveSMS");
    QXmlStreamReader xml(result);
    QString name;QString number;QString text;QString date;
    while(!xml.atEnd() &&  !xml.hasError())
    {
         xml.readNext();
         if(xml.name() == "name")
         {
             xml.readNext();
             name = xml.text().toString();
             if(!name.isEmpty()) xml.readNext();
             //QString name = xml.text().toString();
             /*//xml.readNext();
             xml.readNext(); xml.readNext();
             QString number = xml.text().toString();
             xml.readNext(); xml.readNext();xml.readNext(); xml.readNext();
             xml.readNext(); xml.readNext(); xml.readNext();
             QString date = xml.text().toString();
             xml.readNext(); xml.readNext(); xml.readNext();
             QString text = xml.text().toString();*/
         }
         if(xml.name() == "number")
         {
             xml.readNext();
             number = xml.text().toString();
             if(!number.isEmpty()) xml.readNext();
         }
         if(xml.name() == "date")
         {
             xml.readNext();
             date = xml.text().toString();
             if(!date.isEmpty()) xml.readNext();
         }
         if(xml.name() == "text")
         {
             xml.readNext();
             text = xml.text().toString();
             if(!text.isEmpty()) xml.readNext();
             history *w = new history;
             if(name == number  || name.isEmpty() )
                 w->SetText(number + "                                        ",text,date);
             else
                 w->SetText(name+"        ["+number+"]                      ",text,date);
             MainLayout->addWidget(w);
         }
    }
    widget->setLayout(MainLayout);
    ui->history->addTab(scrollArea ,tr("Bulk SMS History"));
    ui->history->removeTab(0);
}

void dinasms::LoadHistory()
{
   ui->centralWidget->setCursor(QCursor(Qt::WaitCursor));
   this->LoadSMSHistory();
   this->LoadBulkSMSHistory();
   ui->tabWidget->setCurrentIndex(3);
   ui->stackedWidget->setCurrentIndex(1);
   ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
}

void dinasms::ProcessSlot(QString text)
{
    ui->stackedWidget->setCurrentIndex(0);
}

void dinasms::FillSender(QStringList list)
{    
    QStringList FillTo;
    foreach(QString l,list)
    {
        if(hash.contains(l))
            FillTo << hash[l].split("|")[1];
        else
        {
            for(int y=0; y < ui->distribution->topLevelItemCount();y++)
                if(ui->distribution->topLevelItem(y)->text(0) == l)
                    for(int u=0; u < ui->distribution->topLevelItem(y)->childCount();u++)
                        FillTo << hash[ui->distribution->topLevelItem(y)->child(u)->text(0)].split("|")[1];
        }
    }
    for(int r=0; r < FillTo.count()-1 ; r++)
    {
        if(ui->to->text().isEmpty())
            ui->to->setText(FillTo[r]);
        else
            ui->to->setText(ui->to->text() + "," + FillTo[r]);
    }
    if(FillTo.count() > 1)
    {
        ui->to->setText(ui->to->text() + "," + FillTo[FillTo.count()-1]);
        FillTo = ui->to->text().split(',');
        ui->to->setText("");
        FillTo.removeDuplicates();
        ui->to->setText(FillTo[0]);
        for(int r=1; r < FillTo.count()-1 ; r++)
            ui->to->setText( ui->to->text() + "," + FillTo[r]);
        ui->to->setText(ui->to->text() + "," + FillTo[FillTo.count()-1]);
    }
    if(FillTo.count() == 1)
            ui->to->setText(FillTo[0]);
}

 void dinasms::ContactsXML()
{
     QString result = this->Post("cuenta="+user+"&password="+pass+"&command=sms_getAddressBook");
     QXmlStreamReader xml(result);
     QRegExp credit("(<smsCredit>)([0-9]+)(.*)(</smsCredit>)");
     credit.indexIn(result);
     ui->logstats->setText(credit.cap(2)+tr(" credits | ")+tr("Connected as : ") + user);
     ui->Creditlabel->setText(credit.cap(2)+tr(" credits available"));
     while(!xml.atEnd() &&  !xml.hasError())
     {
          xml.readNext();
          QString temp;QString temp1;QString temp2;
          if(xml.name() == "address")
          {
              xml.readNext();
              if(xml.name() == "id")
              {
                xml.readNext();temp = xml.text().toString();
                //qdebug() << "id : " << xml.text().toString() << "\n";
                xml.readNext();xml.readNext();
              }
              QTreeWidgetItem *item = new QTreeWidgetItem(ui->contacts);
              QTreeWidgetItem *item1 = new QTreeWidgetItem(ui->contactview);
              if(xml.name() == "name")
              {
                xml.readNext();temp1 = xml.text().toString();
                //qdebug() << "name : " << xml.text().toString() << "\n";
                item->setText(0,xml.text().toString());
                QPixmap pixmap;pixmap.load(":/images/user.ico");
                item->setIcon(0,QIcon(pixmap));
                item1->setText(0,xml.text().toString());
                item1->setIcon(0,QIcon(":/images/user.ico"));
                xml.readNext();xml.readNext();
              }
              if(xml.name() == "number")
              {
                xml.readNext();temp2 = xml.text().toString();
                //qdebug() << "number : " << xml.text().toString() << "\n";
                item1->setText(1,xml.text().toString());
                item1->setIcon(1,QIcon(":/images/call.ico"));
                xml.readNext();xml.readNext();
                hash[temp1] = temp+"|"+temp2;
              }
          }
     }
     if(xml.hasError())
           QMessageBox::critical(this,"QXSRExample::parseXML", xml.errorString(),QMessageBox::Ok);
     xml.clear();
}

 void dinasms::ChangePwd(QString Change)
 {
     ui->centralWidget->setCursor(QCursor(Qt::WaitCursor));
     QString result = this->Post("cuenta="+user+"&password="+pass+"&newPassword="+Change+"&command=sms_changePassword");
     if (this->CheckError(result))
     {
         pass = Change;
         msgBox.setText(tr("Changed Password SuccessFully!"));
         msgBox.exec();
         ui->old->setText("");
         ui->new1->setText("");
         ui->new2->setText("");
     }
     else
     {
          msgBox.setText(tr("Failed Setting new Password!"));
          msgBox.exec();
     }
 }

void dinasms::ChangePassword()
{
    ui->centralWidget->setCursor(QCursor(Qt::WaitCursor));
    if(ui->old->text().isEmpty() || ui->new1->text().isEmpty() || ui->new2->text().isEmpty())
    {
        QMessageBox msgBox;
        msgBox.setText(tr("Please Enter All inputs!"));
        msgBox.exec();
    }
    else if(ui->old->text() != pass)
    {
        QMessageBox msgBox;
        msgBox.setText(tr("Old Password Not Matching!"));
        msgBox.exec();
    }
    else if(ui->new1->text() != ui->new2->text() || ui->new1->text().isEmpty() || ui->new2->text().isEmpty())
    {
        QMessageBox msgBox;
        msgBox.setText(tr("New Passwords Not Matching!"));
        msgBox.exec();
    }
    else
        this->ChangePwd(ui->new1->text());
    ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
}

void dinasms::ChangeSender()
{    
    ui->centralWidget->setCursor(QCursor(Qt::WaitCursor));
    if( ui->newSender->text().isEmpty() )
    {
        QMessageBox msgBox;
        msgBox.setText(tr("Please Enter New Sender!"));
        msgBox.exec();
    }
    else
    {
        QString result = this->Post("cuenta="+user+"&password="+pass+"&remite="+ui->newSender->text()+"&command=sms_changeFrom");
        if (this->CheckError(result))
        {
             ui->sender->setText(ui->newSender->text());ui->currentSender->setText(ui->newSender->text());
             msgBox.setText(tr("Changed Sender SuccessFully!"));
             msgBox.exec();
             ui->newSender->setText("");
        }
        else
        {
            msgBox.setText(tr("Failed Setting new Sender!"));
            msgBox.exec();
        }
    }
    ui->centralWidget->setCursor(QCursor(Qt::PointingHandCursor));
}
