#ifndef DINASMS_H
#define DINASMS_H

#include <QMainWindow>
#include <QXmlStreamReader>
#include <QAbstractButton>
#include <QTreeWidgetItem>
#include <QtXml/QXmlStreamReader>
#include <QHash>
#include <QString>
#include <QMessageBox>
#include <login.h>

namespace Ui {
    class dinasms;
}

class dinasms : public QMainWindow
{
    Q_OBJECT

public:
    explicit dinasms(QWidget *parent = 0);
    ~dinasms();

signals:
    void Remember(bool);
    void Lang(bool);

public slots:
    void CheckLogin(QString,QString);
    void ChangePassword();
    void ChangeSender();
    void LoadView();
    void ContactsXML();
    void ListsXML();
    void EditContact();
    void RmContact();
    void AddContact();
    void AddNewContact();
    void NewContact();
    void NewList();
    void AddtoList(QTreeWidgetItem *);
    QString Post(QString);
    bool CheckError(QString);
    void LoadHistory();
    void AddItem(QStringList,QTreeWidgetItem *);
    void SendSMS();
    void FillSender(QStringList);
    void LoadSMSHistory();
    void LoadBulkSMSHistory();
    void ChangePwd(QString);
    void ClearAll();
    void ProcessSlot(QString);
    void AddCnt(QString ,QString);
    void EditCnt(QString,QString,QString);
    void LoadButton();
    void ShowLogin();
    void ChangeLanguage(bool);

private:
    Ui::dinasms *ui;
    QHash<QString, QString> hash;
    QMessageBox msgBox;
public:
    QString user;
    QString pass;
    QTabWidget* tab4;
    int count;
    login l;
};



#endif // DINASMS_H
