#include "login.h"
#include "dinasms.h"
#include "ui_login.h"
#include "ui_dinasms.h"
#include "synchttp.h"
#include <qtreecustom.h>
#include <qfile.h>
#include <qtextstream.h>

extern QTranslator translator;
extern QApplication *a;

login::login(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::login)
{
    ui->setupUi(this);
    //setWindowFlags(Qt::Tool);

    QFile file(".dina.cfg");
    if (!file.open (QFile::ReadOnly))
         return;

    QTextStream stream ( &file );

    QString line = stream.readLine();
    QStringList ListUser = line.split(':');
    ListUser.removeDuplicates();
    ListUser.removeAll("");

    line = stream.readLine();
    QStringList Listpass = line.split(':');
    Listpass.removeDuplicates();
    Listpass.removeAll("");

    for (int h = 0;h < ListUser.length() ; h++)
        hash[ListUser[h]] = Listpass[h];

    line = stream.readLine();
    QStringList prefs = line.split(':');

    ui->rememberU->setChecked((prefs[0] == "0")?false:true);
    ui->rememberP->setChecked((prefs[1] == "0")?false:true);
    ui->rememberC->setChecked((prefs[2] == "0")?false:true);
    ui->language->setCurrentIndex((prefs[3]=="0")?0:1);    

    ui->user->addItems( ListUser );

    if(ui->rememberU->isChecked())
    {
        ui->user->setCurrentIndex(0);
        ui->pass->setText(Listpass[0]);
    }
    else
    {
        ui->user->clear();
        ui->user->addItem("");
        ui->user->addItems( ListUser );
    }

    if(ui->rememberC->isChecked() && ui->rememberU->isChecked() && ui->rememberP->isChecked())
    {
        ui->user->setCurrentIndex(0);
        ui->pass->setText(Listpass[0]);//emit(Remember(true));
    }

    file.close(); // when your done.
}
void login::changePass()
{
    if(ui->rememberP->isChecked())
        ui->pass->setText(hash[ui->user->currentText()]);
}

bool login::AutoLogin()
{
    QFile file(".dina.cfg");
    if(!file.open (QFile::ReadOnly))  return false;

    if(ui->rememberC->isChecked() && ui->rememberU->isChecked() && ui->rememberP->isChecked())
    {
        emit(logSuccess(ui->user->currentText(),ui->pass->text()));
        return true;
    }
    return false;
}

void login::logAccount()
{
    QMessageBox msgBox;
    if( ui->user->currentText().isEmpty() || ui->pass->text().isEmpty())
    {
        msgBox.setText(trUtf8("¡Por favor introduce el usuario y la contraseña!"));
        if(ui->label->text() == "Username")
            msgBox.setText(tr("Please Enter Username and Password!"));
        msgBox.exec();
        return;
    }
    //ui->login->SetCursor(QCursor(Qt::WaitCursor));
    QString result = this->Post("cuenta="+ui->user->currentText()+"&password="+ui->pass->text()+"&command=sms_Login");
    if (this->CheckError( result))
    {
        emit(logSuccess(ui->user->currentText(),ui->pass->text()));
        QFile file(".dina.cfg");
        if (file.open (QFile::WriteOnly))
        {
            QTextStream out(&file);
            hash[ui->user->currentText()] = ui->pass->text();
            QString first = ui->user->currentText();
            ui->user->clear();
            ui->user->addItems(hash.keys());
            out << first << ":";
            for(int r=1; r < (hash.count()-1); r++)
                if(hash.keys().at(r) != first)
                    out << hash.keys().at(r) << ":";
            out << hash.keys().at(hash.count()-1) << "\n";

            out << hash[first] << ":";
            for(int r=1; r < hash.count()-1; r++)
                if(hash.keys().at(r) != first)
                  out << hash[hash.keys().at(r)] << ":";
            out << hash[hash.keys().at(hash.count()-1)] << "\n";

            out << ui->rememberU->isChecked() << ":"<< ui->rememberP->isChecked() <<":"<< ui->rememberC->isChecked() << ":" << ui->language->currentIndex();
            file.close();
        }
    }
    else
    {
        msgBox.setText(tr("Error de inicion de sesión!"));
        if(ui->label->text() == "Username")
            msgBox.setText(tr("Failed Logging to the Account!"));
         msgBox.exec();
    }
}

QString login::Post(QString Postdata)
{
    SyncHTTP h("apisms.gestiondecuenta.com");
    QByteArray data(Postdata.toAscii());
    QBuffer postOutput;
    h.syncPost( "/php/comun/ejecutarComando.php",data, &postOutput);
    return postOutput.data();
}

void login::ChangeLang(QString q)
{
    if(q == "English")
        emit(Remember(true));
    else
        emit(Remember(false));
}


void login::ChangeLangu(bool lang)
{
    if(lang)
    {
        ui->label->setText(tr("Username"));
        ui->label_2->setText(trUtf8("Password"));
        ui->label_4->setText(trUtf8("Change Language"));
        ui->rememberC->setText(trUtf8("Connect on start up"));
        ui->rememberP->setText(trUtf8("Remember Password"));
        ui->rememberU->setText(trUtf8("Remember Username"));
        ui->pushButton->setText(trUtf8("Sign in"));
    }
    else
    {
        ui->label->setText(tr("Usuario"));
        ui->label_2->setText(trUtf8("Contraseña"));
        ui->label_4->setText(trUtf8("Elegir idioma"));
        ui->rememberC->setText(trUtf8("Conectar al iniciar"));
        ui->rememberP->setText(trUtf8("Recordar contraseña"));
        ui->rememberU->setText(trUtf8("Recordar usuario"));
        ui->pushButton->setText(trUtf8("Conectarse"));
    }

}

bool login::CheckError(QString result)
{
    QRegExp rx("(<ErrCount>)([0-9]+)(</ErrCount>)");
    int pos = rx.indexIn(result);
    if (pos > -1 && rx.cap(2).compare("0")==0)
            return true;
        return false;
}

login::~login()
{
    delete ui;
}
