#include "qtreecustom.h"

qtreecustom::qtreecustom(QWidget *parent) :
    QTreeWidget(parent)
{

}

bool qtreecustom::dropMimeData(QTreeWidgetItem *parent, int index, const QMimeData *data, Qt::DropAction action)
{
    QList<QUrl> urlList;
    QStringList list;parent->setExpanded(true);
    urlList = data->urls(); // retrieve list of urls
    foreach(QUrl url, urlList)
        list << url.toString();
    emit(DropItems(list,parent));
    return true;
}


QStringList qtreecustom::mimeTypes () const
{
    QStringList qstrList;
    // list of accepted mime types for drop
    qstrList.append("text/uri-list");
    return qstrList;
}


Qt::DropActions qtreecustom::supportedDropActions () const
{
    // returns what actions are supported when dropping
    return Qt::CopyAction | Qt::MoveAction;
}

void qtreecustom::mouseMoveEvent(QMouseEvent *event)
{
    // if not left button - return
        if (!(event->buttons() & Qt::LeftButton)) return;

        // if no item selected, return (else it would crash)
        if (currentItem() == NULL) return;

        QDrag *drag = new QDrag(this);
        QMimeData *mimeData = new QMimeData;
        QList<QUrl> list;
        foreach (QTreeWidgetItem *item, selectedItems()) {
            list.append(QUrl(item->text(0))); // only QUrl in list will be text of actual item
        }
           // mime stuff
        mimeData->setUrls(list);
        drag->setMimeData(mimeData);

           // start drag
        drag->start(Qt::CopyAction | Qt::MoveAction);
}

/*void qtreecustom::dragEnterEvent(QDragEnterEvent *event)
{
    if (event->mimeData()->hasFormat("text/uri-list"))
        {
            event->acceptProposedAction();
        }
}*/
